import os
import sys
if sys.argv[1] == "build_exe":
    from cx_Freeze import setup, Executable
else:
    from distutils.core import setup

if "install" in sys.argv:
    for arg in sys.argv:
        if arg.startswith("--install-lib="):
            break
    else:
        print("ERROR: You should not install FS-UAE Launcher to the default ")
        print("python library location. Instead, use --install-lib to ")
        print("install to a custom location, e.g.:")
        print("python3 setup.py --install-lib=/usr/share/fs-uae-launcher install")
        sys.exit(1)

title = "FS-UAE Launcher"
name = "fs-uae-launcher"
py_name = "fs_uae_launcher"
tar_name = "fs-uae-launcher"
version = "3.1.0dev"
author = "Frode Solheim"
author_email = "frode@fs-uae.net"
package_map = {
    "amitools": ".",
    "arcade": ".",
    "fsbc": ".",
    "fsboot": ".",
    "fsgs": ".",
    "fspy": ".",
    "fstd": ".",
    "fsui": ".",
    "launcher": ".",
    "oyoyo": ".",
    "workspace": ".",
}
packages = sorted(package_map.keys())
scripts = ["fs-uae-launcher"]
extra_dist = [
    "data/Fonts/SairaCondensed-Bold.ttf",
    "data/Fonts/SairaCondensed-Regular.ttf",
    "data/Fonts/SairaSemiCondensed-Medium.ttf",
    "data/Fonts/SairaCondensed-Medium.ttf",
    "data/Fonts/SairaCondensed-SemiBold.ttf",

    "docs/compiling.md",
    "docs/file-database.md",

    "src/Makefile",

    "src/icons/colorizeicon.sh",
    "src/icons/glowicon.sh",

    "src/icons/TitleBarMinimize.svg",
    "src/icons/TitleBarMaximize.svg",
    "src/icons/TitleBarClose.svg",
    "src/icons/TitleBarMenu.svg",

    "src/icons/tango/Makefile",
    "src/icons/tango/README.md",
    "src/icons/tango/64/Makefile",
    "src/icons/tango/64/drive-harddisk-3.svg",
    "src/icons/tango/64/drive-harddisk-4.svg",
    "src/icons/tango/64/drive-harddisk.svg",
    "src/icons/tango/64/drive-harddisk-2.svg",
    "src/icons/tango/overlays/system-search.png",
    "src/icons/amigaforever/volumeoverlays/AmigaForever.png",
    "src/icons/adwaita/Makefile",
    "src/icons/adwaita/COPYING",
    "src/icons/adwaita/COPYING_LGPL",
    "src/icons/adwaita/README.md",
    "src/icons/adwaita/COPYING_CCBYSA3",
    "src/icons/adwaita/64/Makefile",
    "src/icons/adwaita/64/application-x-firmware.png",
    "src/icons/Makefile",
    "src/icons/gnome/volume-overlays/applications-games.png",
    "src/icons/gnome/overlays/applications-games.png",
    "src/icons/gnome/overlays/preferences-system.png",
    "src/icons/humanity/Makefile",
    "src/icons/humanity/README.md",
    "src/icons/humanity/64/application-x-lha.svg",
    "src/icons/humanity/64/applications-simulation.svg",
    "src/icons/humanity/64/input-mouse.svg",
    "src/icons/humanity/64/system-file-manager-3.svg",
    "src/icons/humanity/64/menu-editor.svg",
    "src/icons/humanity/64/system-file-manager-6.svg",
    "src/icons/humanity/64/Makefile",
    "src/icons/humanity/64/system-software-update-2-no-shadow.svg",
    "src/icons/humanity/64/help-contents.svg",
    "src/icons/humanity/64/edit-clear.svg",
    "src/icons/humanity/64/preview-file.svg",
    "src/icons/humanity/64/accessories-calculator.svg",
    "src/icons/humanity/64/clock.svg",
    "src/icons/humanity/64/applications-graphics.svg",
    "src/icons/humanity/64/audio-card.svg",
    "src/icons/humanity/64/stock_person.svg",
    "src/icons/humanity/64/system-file-manager-5.svg",
    "src/icons/humanity/64/extension.svg",
    "src/icons/humanity/64/system-file-manager-4.svg",
    "src/icons/humanity/64/system-file-manager-7.svg",
    "src/icons/humanity/64/system-software-update.svg",
    "src/icons/humanity/64/preferences-desktop-sound.svg",
    "src/icons/humanity/64/preferences-desktop-locale.svg",
    "src/icons/humanity/64/input-keyboard.svg",
    "src/icons/humanity/64/system-file-manager-1.svg",
    "src/icons/humanity/64/system-file-manager-8.svg",
    "src/icons/humanity/64/user-desktop.svg",
    "src/icons/humanity/64/video-display.svg",
    "src/icons/humanity/64/logviewer.svg",
    "src/icons/humanity/64/system-file-manager.svg",
    "src/icons/humanity/64/gnome-power-manager.svg",
    "src/icons/humanity/64/network-server.svg",
    "src/icons/humanity/64/applications-fonts.svg",
    "src/icons/humanity/64/prefs-overlay.png",
    "src/icons/humanity/64/system-software-update-2.svg",
    "src/icons/humanity/64/system-file-manager-2.svg",
    "src/icons/humanity/64/view-fullscreen.svg",
    "src/icons/humanity/64/applications-arcade.svg",
    "src/icons/humanity/overlays/applications-utilities.png",
    "src/icons/humanity/overlays/Utilities.png",
    "src/icons/humanity/overlays/preferences-system.png",
    "src/icons/humanity/overlays/system-help.png",
    "src/icons/humanity/24/media-optical.svg",
    "src/icons/humanity/24/media-floppy.svg",
    "src/icons/humanity/24/drive-harddisk.svg",
    "src/icons/shared/tango-software-update-available.png",
    "src/icons/fontawesome/Makefile",
    "src/icons/fontawesome/tabs/memory.png",
    "src/icons/fontawesome/tabs/microchip.png",
    "src/icons/fontawesome/tabs/Makefile",
    "src/icons/fontawesome/tabs/save.png",
    "src/icons/fontawesome/tabs/home.png",
    "src/icons/fontawesome/tabs/tasks.png",
    "src/icons/fontawesome/tabs/gamepad.png",
    "src/icons/fontawesome/tabs/hdd.png",
    "src/icons/fontawesome/tabs/compact-disc.png",
    "src/icons/fontawesome/16/Makefile",
    "src/icons/fontawesome/16/cog.png",
    "src/icons/fontawesome/LICENSE.txt",
    "src/icons/human/24/gnome-dev-memory.png",
    "src/icons/human/24/gnome-dev-harddisk.png",
    "src/icons/human/24/gnome-dev-floppy.png",
    "src/icons/human/24/go-home.png",
    "src/icons/human/24/gnome-dev-cdrom.png",
    "src/icons/system/utilities/checksum/tango-application-certificate.svg",
    "src/icons/system/utilities/checksum/humanity-multipart-encrypted.svg",
    "src/icons/system/utilities/checksum/tango-application-certificate.png",
    "src/icons/64/Makefile",
    "src/icons/64/fs-uae-arcade.svg",
    "src/icons/64/fs-uae-launcher.svg",
    "src/icons/overlays/fs-uae-volume_selected.png",
    "src/icons/overlays/fs-uae-volume.png",
]


# add unique parent directories to sys.path
for p in set(package_map.values()):
    sys.path.insert(0, p)

setup_packages = set()
package_dir = {}
package_data = {}
setup_options = {}
setup_cmdclass = {}


res_dirs = []
res_dirs.append('amitools/res')
res_dirs.append('arcade/res')
res_dirs.append('fsbc/res')
res_dirs.append('fsboot/res')
res_dirs.append('fsgs/res')
res_dirs.append('fspy/res')
res_dirs.append('fstd/res')
res_dirs.append('fsui/res')
res_dirs.append('launcher/res')
res_dirs.append('oyoyo/res')
res_dirs.append('workspace/res')


def add_package(package_name, package_dir_name):
    setup_packages.add(package_name)
    local_name = package_name.replace(".", "/")
    if os.path.exists(local_name):
        package_dir_path = local_name
    else:
        package_dir_path = package_dir_name + "/" + local_name
    package_dir[package_name] = package_dir_path
    package_data[package_name] = []
    for dir_path, dir_names, file_names in os.walk(package_dir_path):
        for name in file_names:
            n, ext = os.path.splitext(name)
            if ext in [".py", ".pyc", ".pyo", ".swp", "*.swo"]:
                continue
            path = os.path.join(dir_path[len(package_dir_path) + 1:], name)
            package_data[package_name].append(path)
            setup_packages.add(package_name)


def add_packages():
    for name in sorted(packages):
        dir_name = package_map[name]
        add_package(name, dir_name)
        for dir_path, dir_names, file_names in os.walk(
                package_dir[name]):
            for n in file_names:
                if n != "__init__.py":
                    continue
                p_name_rev = []
                path = dir_path
                while os.path.exists(os.path.join(path, "__init__.py")):
                    p_name_rev.append(os.path.basename(path))
                    path = os.path.dirname(path)
                sub_name = ".".join(reversed(p_name_rev))
                package_dir[sub_name] = (package_dir[name] + "/" +
                                         sub_name.replace(".", "/"))
                add_package(sub_name, dir_name)


add_packages()

setup_kwargs = {
    "name": py_name,
    "version": version,
    "author": author,
    "author_email": author_email,
    "packages": setup_packages,
    "package_dir": package_dir,
    "package_data": package_data,
    "options": setup_options,
    "cmdclass": setup_cmdclass,
}

if sys.argv[1] == "build_exe":
    import cx_Freeze
    if sys.platform == "win32":
        setup_kwargs["executables"] = [
            Executable(s, base="Win32GUI", icon="icon/" + s + ".ico")
                for s in scripts]
    else:
        setup_kwargs["executables"] = [Executable(s) for s in scripts]

    setup_kwargs["version"] = "3.1.0"
    build_exe_options = {
        "includes": [
        #    "ctypes",
        #    "logging",
        ],
        "excludes": [
            "tkconstants",
            "tkinter",
            "tk",
            "tcl",
        ],
        "include_files": [],
        "zip_includes": [],
    }
    if int(cx_Freeze.version.split(".")[0]) >= 5:
        build_exe_options["zip_include_packages"] = "*"
        build_exe_options["zip_exclude_packages"] = []
    #for res_dir in res_dirs:
    #    print(res_dir)
    #    build_exe_options["zip_includes"].append((res_dir, res_dir))

    for name in sorted(package_map.keys()):
        sp = os.path.join(name, "res")
        if not os.path.exists(sp):
            # setup with alternative source dir
            sp = os.path.join(package_map[name], name, "res")
        if not os.path.exists(sp):
            continue
        dp = os.path.join(name, "res")
        # dp = os.path.join("share", tar_name, dp)
        # build_exe_options["include_files"].append((sp, dp))
        for dir_path, dir_names, file_names in os.walk(sp):
            for name in file_names:
                p = os.path.join(dir_path, name)
                rp = p[len(sp) + 1:]
                # build_exe_options["zip_includes"].append(
                #     (p, os.path.join(dp, rp)))
                build_exe_options["include_files"].append(
                    (p, os.path.join(dp, rp)))
                # print(p, rp)
    setup_options["build_exe"] = build_exe_options
    if os.path.exists("extra_imports.py"):
        build_exe_options["includes"].append("extra_imports")

    build_exe_options["packages"] = setup_packages


if sys.platform == "win32" and False:
    setup_kwargs["windows"] = scripts

if sys.platform == "darwin":
    setup_kwargs["name"] = title
    setup_kwargs["version"] = "3.1.0"
else:
    setup_kwargs["scripts"] = scripts

setup(**setup_kwargs)
